<?php
/**
* @version		1.2
* @package		DJ Catalog
* @subpackage	DJ Catalog Component
* @copyright	Copyright (C) 2007 - 2008 DJ-Projects. All rights reserved.
* @license		This code cannot be redistributed without permission from DJ-Projects - http://design-joomla.eu
* @autor url    http://design-joomla.eu
* @autor email  sales@design-joomla.eu
* @Developers   Lukasz Ciastek - lukasz.ciastek@design-joomla.eu, Michal Olczyk - michal.olczyk@design-joomla.eu
*/
defined('_JEXEC') or die ('Restricted access');
jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');
$lang = & JFactory::GetLanguage();
$lang->load('com_djcatalog');

class DJCatalogController extends JController
{
    function __construct($default = array ())
    {
        parent::__construct($default);

        $this->registerTask('add', 'edit');
        $this->registerTask('addItem', 'editItem');
        $this->registerTask('apply', 'save');
        $this->registerTask('applyItem', 'saveItem');
        $this->registerTask('unpublish', 'publish');
        $this->registerTask('applyConfig', 'saveConfig');
		$this->registerTask('addProducer', 'editProducer');
		$this->registerTask('applyProducer', 'saveProducer');
		
		$this->footer = '<br /><div style="margin: 0 auto; text-align: center; width: 100%"><a target="_blank" href="http://design-joomla.eu"><img src="'.JURI::base().'components/com_djcatalog/images/designjoomla.jpg" alt="Design-Joomla.eu" /><br/>joomla templates & addons</a></div>';
    }

    function display()
    {
        JRequest::setVar('view', 'categories');
        parent::display(); echo $this->footer;
    }

    function makeimg($adres)
    {
        $par = &JComponentHelper::getParams( 'com_djcatalog' );
    
    	$nw = -1;
		$nh = -1;
		
        $nw = (int)$par->get('th_width',-1);
        $nh = (int)$par->get('th_height',-1);
		
		/* ------------------- */
		if (!$adres)
            return false;
		
		 if (! list ($w, $h, $type, $attr) = getimagesize($adres)) {
            if (! list ($w, $h, $type, $attr) = getimagesize($adres)) {
                return false;
    	    }
	    }
		
        switch($type)
        {
            case 1:
                $simg = imagecreatefromgif($adres);
                break;
            case 2:
                $simg = imagecreatefromjpeg($adres);
                break;
            case 3:
                $simg = imagecreatefrompng($adres);
                break;
        }
		
		$x = 0;
		$y = 0;
		$cw = $w;
		$ch = $h;
		
		$nw_half = (int)floor($nw/2);
		$nh_half = (int)floor($nh/2);
		$w_half = (int)floor($w/2);
		$h_half = (int)floor($h/2);
		
		if ($nw == 0 && $nh == 0) {
			$nw = 200;
			$nh = (int)(floor(($nw * $h) / $w));
		}
		elseif ($nw == 0) {
			$nw = (int)(floor(($nh * $w) / $h));
		}
		elseif ($nh == 0) {
			$nh = (int)(floor(($nw * $h) / $w));
		}
		elseif ($nw < $w || $nh < $h) {
	        if ($nw <= $nh)
	        {
				if ($w <= $h) {
					$ch = $h;
					$temp_w = (int)floor(($h * $nw)/$nh);
					if ($temp_w > $w) {
						$cw = $w;
					}
					else {
						$cw = $temp_w;
						$x = $w_half - (int)($temp_w/2);
					}
				}
				elseif ($w > $h) {
					$ch = $h;
					$temp_w = (int)floor(($h * $nw)/$nh);
					if ($temp_w > $w) {
						$cw = $w;
					}
					else {
						$cw = $temp_w;
						$x = $w_half - (int)($temp_w/2);
					}
				}
	        } 
			elseif ($nw > $nh) {
	        	if ($w <= $h) {
					$cw = $w;
					$temp_h = (int)floor(($nh * $w)/$nw);
					if ($temp_h > $h) {
						$ch = $h;
					}
					else {
						$ch = $temp_h;
						$y = $h_half - (int)($temp_h/2);
					}
				}
				elseif ($w > $h) {
					$cw = $w;
					$temp_h = (int)floor(($nh * $w)/$nw);
					if ($temp_h > $h) {
						$ch = $h;
					}
					else {
						$ch = $temp_h;
						$y = $h_half - (int)($temp_h/2);
					}
				}        
	        }
		}
		elseif ($nw == -1 || $nh == -1) {
			return false;
		}
		$dimg = imagecreatetruecolor($nw, $nh);
		$bgColor = imagecolorallocate($dimg, 255, 255, 255);
	    imagefill($dimg, 0, 0, $bgColor);
 		imagecopyresampled($dimg, $simg, 0, 0, $x, $y, $nw, $nh, $cw, $ch);
		
		$thumb_path = $adres.'.th.jpg';
	    if (is_file($thumb_path))
			unlink($thumb_path);
	  
	    imagejpeg($dimg, $thumb_path, 85);
		
		return true;
	}
		
    function makeimg_s($adres)
    {
        $par = &JComponentHelper::getParams( 'com_djcatalog' );
    
    	$nw = -1;
		$nh = -1;
        $nw = $par->get('smallth_width',-1);
        $nh = $par->get('smallth_height',-1);
		
		/* ------------------- */
		if (!$adres)
            return false;
		
		 if (! list ($w, $h, $type, $attr) = getimagesize($adres)) {
            if (! list ($w, $h, $type, $attr) = getimagesize($adres)) {
                return false;
    	    }
	    }
		
        switch($type)
        {
            case 1:
                $simg = imagecreatefromgif($adres);
                break;
            case 2:
                $simg = imagecreatefromjpeg($adres);
                break;
            case 3:
                $simg = imagecreatefrompng($adres);
                break;
        }
		
		$x = 0;
		$y = 0;
		$cw = $w;
		$ch = $h;
		
		$nw_half = (int)floor($nw/2);
		$nh_half = (int)floor($nh/2);
		$w_half = (int)floor($w/2);
		$h_half = (int)floor($h/2);
		
		if ($nw == 0 && $nh == 0) {
			$nw = 50;
			$nh = (int)(floor(($nw * $h) / $w));
		}
		elseif ($nw == 0) {
			$nw = (int)(floor(($nh * $w) / $h));
		}
		elseif ($nh == 0) {
			$nh = (int)(floor(($nw * $h) / $w));
		}
		elseif ($nw < $w || $nh < $h) {
	        if ($nw <= $nh)
	        {
				if ($w <= $h) {
					$ch = $h;
					$temp_w = (int)floor(($h * $nw)/$nh);
					if ($temp_w > $w) {
						$cw = $w;
					}
					else {
						$cw = $temp_w;
						$x = $w_half - (int)($temp_w/2);
					}
				}
				elseif ($w > $h) {
					$ch = $h;
					$temp_w = (int)floor(($h * $nw)/$nh);
					if ($temp_w > $w) {
						$cw = $w;
					}
					else {
						$cw = $temp_w;
						$x = $w_half - (int)($temp_w/2);
					}
				}
	        } 
			elseif ($nw > $nh) {
	        	if ($w <= $h) {
					$cw = $w;
					$temp_h = (int)floor(($w * $nh)/$nw);
					if ($temp_h > $h) {
						$ch = $h;
					}
					else {
						$ch = $temp_h;
						$y = $h_half - (int)($temp_h/2);
					}
				}
				elseif ($w > $h) {
					$cw = $w;
					$temp_h = (int)floor(($nh * $w)/$nw);
					if ($temp_h > $h) {
						$ch = $h;
					}
					else {
						$ch = $temp_h;
						$y = $h_half - (int)($temp_h/2);
					}
				}        
	        }
		}
		elseif ($nw == -1 || $nh == -1) {
			return false;
		}
		$dimg = imagecreatetruecolor($nw, $nh);
		$bgColor = imagecolorallocate($dimg, 255, 255, 255);
	    imagefill($dimg, 0, 0, $bgColor);
		
 		imagecopyresampled($dimg, $simg, 0, 0, $x, $y, $nw, $nh, $cw, $ch);
		
		$thumb_path = $adres.'.ths.jpg';
	    if (is_file($thumb_path))
			unlink($thumb_path);
	  
	    imagejpeg($dimg, $thumb_path, 85);
		
		return true;
	}

    function items()
    {
        JRequest::setVar('view', 'items');
        parent::display(); echo $this->footer;
    }
    
    function producers()
    {
        JRequest::setVar('view', 'producers');
        parent::display(); echo $this->footer;
    }
    
    function config()
    {
        JRequest::setVar('view', 'config');
        parent::display(); echo $this->footer;
    }
    
    function edit()
    {
        JRequest::setVar('view', 'edit');
        parent::display(); echo $this->footer;
    }
    
    function nocategoryitems()
    {
        JRequest::setVar('view', 'nocategoryitems');
        parent::display(); echo $this->footer;
    }
	
	function editProducer()
	{	
		JRequest::setVar('view','editProducer');
		parent::display(); echo $this->footer;
	}

function editItem()
{
    JRequest::setVar('view', 'editItem');
    parent::display(); echo $this->footer;
}




function save()
{
    global $mainframe;
    $row = & JTable::getInstance('categories', 'table');
    if (!$row->bind(JRequest::get('post')))
    {
    	$link = 'index.php?option=com_djcatalog';
		$msg = $row->getError();
		$mainframe->redirect($link, $msg);
    }
	if (!$row->check()) {
		$link = 'index.php?option=com_djcatalog';
		$msg = $row->getError();
		$mainframe->redirect($link, $msg);
		}
    if (!$row->store())
    {
        $link = 'index.php?option=com_djcatalog';
		$msg = $row->getError();
		$mainframe->redirect($link, $msg);
    }
    switch($this->_task)
    {
        case 'apply':
            $link = 'index.php?option=com_djcatalog&task=edit&cid[]='.$row->id;
            $msg = JText::_('CHANGES_SAVED');
            break;
        case 'save':
        default:
            $link = 'index.php?option=com_djcatalog';
            $msg = JText::_('ITEM_SAVED');
            break;
    }

    $mainframe->redirect($link, $msg);
}


function saveItem() {
    global $mainframe;

    $row = & JTable::getInstance('items', 'table');

    if (!$row->bind(JRequest::get('post')))
    {
		$link = 'index.php?option=com_djcatalog&task=items';
		$msg = $row->getError();
		$mainframe->redirect($link, $msg);
    }

    $row->description = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
    $row->intro_desc = JRequest::getVar('intro_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
    
	
	//removing images from folder and from database
    $images = $row->image_url;
    $usun = $_POST['usun'];
    $sciezka_do_usuniecia = JPATH_BASE."/../components/com_djcatalog/images/";

    for ($i = 0; $i < count($usun); $i++)
    {

        $images = str_replace($usun[$i].';', '', $images);
        //deleting the main image
        if (JFile::exists($sciezka_do_usuniecia.$usun[$i]))
        {
            JFile::delete($sciezka_do_usuniecia.$usun[$i]);
        }
        //deleting thumbnail of image
        if (JFile::exists($sciezka_do_usuniecia.$usun[$i].'.th.jpg'))
        {
            JFile::delete($sciezka_do_usuniecia.$usun[$i].'.th.jpg');
        }
        //deleting icon of image
        if (JFile::exists($sciezka_do_usuniecia.$usun[$i].'.ths.jpg'))
        {
            JFile::delete($sciezka_do_usuniecia.$usun[$i].'.ths.jpg');
        }
    }

    //removing file from folder and from database
    $files = $row->files_url;
    $usun = $_POST['usun_plik'];
    $sciezka_do_usuniecia = JPATH_BASE."/../components/com_djcatalog/files/";

    for ($i = 0; $i < count($usun); $i++)
    {

        $files = str_replace($usun[$i].';', '', $files);
        //deleting the file
        if (JFile::exists($sciezka_do_usuniecia.$usun[$i]))
        {
            JFile::delete($sciezka_do_usuniecia.$usun[$i]);
        }
    }

    //add images
    $pliki = $_FILES['image'];

    for ($i = 0; $i < count($pliki['name']); $i++)
    {
        if (substr($pliki['type'][$i], 0, 5) == "image")
        {
            $nazwa = md5(microtime()).''.$pliki['name'][$i];
            $images .= $nazwa;
            $images .= ";";
            $sciezka = JPATH_BASE."/../components/com_djcatalog/images/".$nazwa;
            move_uploaded_file($pliki['tmp_name'][$i], $sciezka);
            $this->makeimg($sciezka);
            if ($i == 0)
            {
                $this->makeimg_s($sciezka);
            } //tylko dla pierwszego obrazka miniaturka

        }
    }
    $row->image_url = $images;


    //add files
    $plikii = $_FILES['files'];

    for ($i = 0; $i < count($plikii['name']); $i++)
    {
        if ($plikii['type'][$i] != "")
        {
            $nazwaa = md5(microtime()).''.$plikii['name'][$i];
            $files .= $nazwaa;
            $files .= ";";
            $sciezka = JPATH_BASE."/../components/com_djcatalog/files/".$nazwaa;
            move_uploaded_file($plikii['tmp_name'][$i], $sciezka);
        }
    }
    $row->files_url = $files;
	
	if(!$row->ordering){
			$query = "SELECT ordering FROM #__djcat_items WHERE cat_id = ".$row->cat_id." ORDER BY ordering DESC LIMIT 1";
			$db =& JFactory::getDBO();		
			$db->setQuery($query);
			$order =$db->loadObject();
			$row->ordering = $order->ordering + 1;
	}
	
	if (!$row->check())
    {
        $link = 'index.php?option=com_djcatalog&task=items';
		$msg = $row->getError();
		$mainframe->redirect($link, $msg);
    }
    if (!$row->store())
    {
        $link = 'index.php?option=com_djcatalog&task=items';
		$msg = $row->getError();
		$mainframe->redirect($link, $msg);
    }

    switch($this->_task)
    {
        case 'applyItem':
            $link = 'index.php?option=com_djcatalog&task=editItem&cid[]='.$row->id;
            $msg = JText::_('CHANGES_SAVED');
            break;
        case 'saveItem':
        default:
            $link = 'index.php?option=com_djcatalog&task=items';
            $msg = JText::_('ITEM_SAVED');
            break;
    }
    $mainframe->redirect($link, $msg);
}

function publish()
{
    global $option;
    $task = JRequest::getVar('t', 'post');
    $cid = JRequest::getVar('cid', array (), '', 'array');

    if ($task == "items" or $task == "nocategoryitems")
    {
        if ($this->_task == 'publish')
        {
            $publish = 1;
        }
        else
        {
            $publish = 0;
        }
        $nlTable = & JTable::getInstance('items', 'table');
        $nlTable->publish($cid, $publish);
        $this->setRedirect('index.php?option=com_djcatalog&task='.$task.'');
    }
    else
    {
        if ($this->_task == 'publish')
        {
            $publish = 1;
        }
        else
        {
            $publish = 0;
        }
        $nlTable = & JTable::getInstance('categories', 'table');
        $nlTable->publish($cid, $publish);
        $this->setRedirect('index.php?option=com_djcatalog');
    }


}

function cancel()
{
    global $mainframe;
    $mainframe->redirect('index.php?option=com_djcatalog');
}

function cancelItem()
{
    global $mainframe;
    $mainframe->redirect('index.php?option=com_djcatalog&task=items');

}

function cancelProducer()
{
    global $mainframe;
    $mainframe->redirect('index.php?option=com_djcatalog&task=producers');

}

function remove()
{
    global $mainframe;
    $cid = JRequest::getVar('cid', array (), '', 'array');
    $db = & JFactory::getDBO();
    if (count($cid))
    {
    	$db->setQuery("SELECT * FROM #__djcat_categories");
		$catlist = $db->loadObjectList();
    	$tree = new CatTree();
		$tree->buildTree($catlist);
    	$root = &$tree->getRoot();
		$categoryList = array();
		foreach($cid as $catid){
			$newList = getChildrenList($root,$catid);
			$categoryList = array_merge($categoryList, $newList);
		}
		$categoryList = array_unique($categoryList);
		$cids = implode(',', $categoryList);
        $query = "DELETE FROM #__djcat_categories WHERE ID IN ( ".$cids." )";
        $db->setQuery($query);
        if (!$db->query())
        {
            echo "script alert('".$db->getErrorMsg()."');
				window.history.go(-1); </script>\n";
        }


    }
    $mainframe->redirect('index.php?option=com_djcatalog', JText::_('ITEM_REMOVED'));
}

function removeItem()

{
    $task = JRequest::getVar('t', 'post');
    global $mainframe;
    $cid = JRequest::getVar('cid', array (), '', 'array');
    $db = & JFactory::getDBO();
    if (count($cid))
    {
        $cids = implode(',', $cid);
        $query = "DELETE FROM #__djcat_items WHERE id IN ( ".$cids." )";
        $db->setQuery($query);
        if (!$db->query())
        {
            echo "script alert('".$db->getErrorMsg()."');
				window.history.go(-1); </script>\n";
        }
    }
    $mainframe->redirect('index.php?option=com_djcatalog&task='.$task.'', JText::_('ITEM_REMOVED'));
}
function saveProducer()
	{
		global $mainframe;
		$row =& JTable::getInstance('producers','table');
		if(!$row->bind(JRequest::get('post')))
		{
			echo "<script> alert('".$row->getError()."');
			window.history.go(-1); </script>\n";
			exit();
		}
			if(!$row->store())
		{
			echo "<script> alert('".$row->getError()."');
			window.history.go(-1); </script>\n";
			exit();
		}
		switch($this->_task)
		{
			case 'applyProducer':
				$link = 'index.php?option=com_djcatalog&task=editproducer&cid[]='.$row->id;
				$msg = 'Dokonane zmiany zostały zapisane!';
				break;
			case 'saveProducer':
			default:
				$link = 'index.php?option=com_djcatalog&task=producers';
				$msg = 'Zapisano!';
				break;
		}
		
		$mainframe->redirect($link, $msg);
	}
function removeProducers()

{
    /*$task = JRequest::getVar('t', 'producers');
    global $mainframe;
    $cid = JRequest::getVar('cid', array (), '', 'array');
    $db = & JFactory::getDBO();
    if (count($cid))
    {
        $cids = implode(',', $cid);
        $query = "DELETE FROM #__djcat_producer WHERE id IN ( ".$cids." )";
        $db->setQuery($query);
        if (!$db->query())
        {
            echo "script alert('".$db->getErrorMsg()."');
				window.history.go(-1); </script>\n";
        }
    }
    $mainframe->redirect('index.php?option=com_djcatalog&task='.$task.'', JText::_('ITEM_REMOVED'));
	*/
		$task = JRequest::getVar( 't','producers');
		global $mainframe; 

		$cid = JRequest::getVar( 'cid', array(), '', 'array');

		$db =& JFactory::getDBO();

		if(count($cid))

		{	
			$cids = implode(',', $cid);		
			$query = "SELECT id, name FROM #__djcat_items WHERE producer_id IN ( ".$cids." )";
			$db->setQuery( $query );
			$items = $db->loadObjectList();
			$items_c=count($items);
			if($items_c>0){
				$msg= JText::_('PRODUCER_REMOVED_ALERT').'<br /><span style="padding-left:30px;" >';
				foreach($items as $it){
					$msg.='<a href = "index.php?option=com_djcatalog&task=editItem&cid[]='.$it->id.'" >'.$it->name.'</a> , ';
				}
				$msg.="</span>";
			}else{
				$query = "DELETE FROM #__djcat_producer WHERE id IN ( ".$cids." )";
				$db->setQuery( $query );
				if(!$db->query())
				{
					echo "script alert('".$db->getErrorMsg()."');
					window.history.go(-1); </script>\n";
				}	
			$msg=JText::_('ITEM_REMOVED');
			}
		}

		$mainframe->redirect('index.php?option=com_djcatalog&task='.$task.'', $msg);
	
}


function applyConfig()
{
    global $mainframe;
    jimport('joomla.filesystem.file');

    $reg = new JRegistry('com_ccourses');

    $data = JFile::read(JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini');
    $reg->loadINI($data);
    $unit = $reg->getValue('price_unit');
    $unit_side = $reg->getValue('unit_side');
    $search_items = $reg->getValue('search_items');

    $file = JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini';
    $registry = new JRegistry('com_djcatalog');

    $sid = JRequest::getVar('price_unit', '', 'post', 'string');
    $cid = JRequest::getVar('unit_side', '', 'post', 'int');
    $iid = JRequest::getVar('search_items', '', 'post', 'int');
    $limit = JRequest::getVar('limit', '', 'post', 'int');

    $registry->setValue('limit', $limit);
    $registry->setValue('price_unit', $unit);
    $registry->setValue('unit_side', $unit_side);
    $registry->setValue('search_items', $search_items);

    $ini = $registry->toString('INI', 'com_djcatalog');
    JFile::write($file, $ini);
    $msg = JText::_('CONFIG_APPLIED');
    $mainframe->redirect('index.php?option=com_djcatalog', $msg);
}

	function orderup(){
		global $mainframe;

		$db		= & JFactory::getDBO();

		$cid = JRequest::getVar( 'cid', array(), '', 'array');
		$cat_id = JRequest::getVar( 'cat_id', '', '', 'int');
		$ord = JRequest::getVar('order');

		
		if (isset( $cid[0] ))
		{
			$row = & JTable::getInstance('items','table');
			$row->load( (int) $cid[0] );
			$row->move(-1, 'cat_id = ' . (int) $row->cat_id );
		}
		$mainframe->redirect('index.php?option=com_djcatalog&task=items&cat_id='.$cat_id.'&order='.$ord.'');
	}
	
	function orderdown(){
		global $mainframe;

		$db		= & JFactory::getDBO();

		$cid = JRequest::getVar( 'cid', array(), '', 'array');
		$cat_id = JRequest::getVar( 'cat_id', '', '', 'int');
		$ord = JRequest::getVar('order');
		
		if (isset( $cid[0] ))
		{
			$row = & JTable::getInstance('items','table');
			$row->load( (int) $cid[0] );
			$row->move(1, 'cat_id = ' . (int) $row->cat_id);
		}
		$mainframe->redirect('index.php?option=com_djcatalog&task=items&cat_id='.$cat_id.'&order='.$ord.'');
	}
	
	
	function saveOrder()
	{
		global $mainframe;
	
		$db			= & JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), '', 'array');
		$order = JRequest::getVar( 'order_p', array (), '', 'array' );
		$cat_id = JRequest::getVar( 'cat_id', '', '', 'int');
		$ord = JRequest::getVar('order');
		$total		= count($cid);
		$conditions	= array ();
		
		$row = & JTable::getInstance('items','table');

		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
				$condition = 'cat_id = ' . (int) $row->cat_id;
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array ($row->id, $condition);
			}
		}

		foreach ($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}
		$mainframe->redirect('index.php?option=com_djcatalog&task=items&cat_id='.$cat_id.'&order='.$ord.'');
	}
	
	function testCat() {
		global $mainframe;
		$db =& JFactory::getDBO();

		$query = "SELECT * FROM #__djcat_categories";
		$db->setQuery( $query );
		$items = $db->loadObjectList();
		$tree = new CatTree();
		$tree->buildTree($items);
		$root = &$tree->getRoot();
		$this->printTree($root);
	}
	
	function printTree(&$root, $level = 0) {
		$children = $root->getChildren();
		foreach ( $children as $category) {
			for ($i = 0; $i < $level; $i ++)
				echo '-';
			echo ' '.$category->name.'<br />';
			$this->printTree($category, $level+1);			
		}
	}
}
