<?php
/**
* @version		1.2
* @package		DJ Catalog
* @subpackage	DJ Catalog Component
* @copyright	Copyright (C) 2007 - 2008 DJ-Projects. All rights reserved.
* @license		This code cannot be redistributed without permission from DJ-Projects - http://design-joomla.eu
* @autor url    http://design-joomla.eu
* @autor email  sales@design-joomla.eu
* @Developers   Lukasz Ciastek - lukasz.ciastek@design-joomla.eu, Michal Olczyk - michal.olczyk@design-joomla.eu
*/
class Category
{
    public $id;
    public $name;
	public $alias;
    public $parent_id;
    public $published;
    public $children;

    function __construct()
    {
        $this->id = 0;
        $this->name = '';
		$this->alias = '';
        $this->parent_id = null;
        $this->published = 0;
        $this->children = array ();
    }
    function Category()
    {
        $this->__construct();
    }

    function setCategory($id, $name, $alias, $parent_id, $published = 0)
    {
        $this->id = $id;
        $this->name = $name;
		$this->alias = $alias;
        $this->parent_id = $parent_id;
        $this->published = $published;
    }
    function getChildren()
    {
        return $this->children;
    }
}

class CatTree
{
    public $node;

    function __construct()
    {
        $this->node = new Category();
    }

    function CatTree()
    {
        $this->__construct();
    }

    function setCatTree( & $category)
    {
        $this->node = $category;
    }

    function addChild($child)
    {
        $this->node->children[$child->id] = $child;
    }

    function getRoot()
    {
        return $this->node;
    }

    function buildTree( & $categoryList)
    {
        if (is_null($categoryList)) return;
        foreach ($categoryList as $category)
        {
            if ($this->node->id == $category->parent_id)
            {
                $newCategory = new Category();
                $newCategory->setCategory($category->id, $category->name, $category->alias, $category->parent_id, $category->published);
                $newNode = new CatTree();
                $newNode->setCatTree($newCategory);
                $this->addChild($newCategory);
                $newNode->buildTree($categoryList);
            }
        }
    }
}

class DjOptionCategory
{
    public $text;
    public $value;
    public $disable;

    function __construct()
    {
        $text = null;
        $value = null;
        $disable = null;
    }
    function DjOptionCategory()
    {
        $this->__construct();
    }
}

function printCategoryList( & $root, $level = 0, & $position = 0)
{
    $children = $root->getChildren();
    foreach ($children as $category)
    {
        $checked = JHTML::_('grid.id', $position, $category->id);
        $published = JHTML::_('grid.published', $category, $position);
        $catprefix = '';
        for ($i = 0; $i < $level; $i++)
        $catprefix .= '&nbsp;&nbsp;';
        $category->name = JHTML::link('index.php?option=com_djcatalog&task=edit&cid[]='.$category->id, $catprefix.$category->name);
?>
<tr>
    <td>
        <?php
        echo $checked;
        ?>
    </td>
    <td>
        <?php
        echo $category->id;
        ?>
    </td>
    <td>
        <?php
        echo $category->name;
        ?>
    </td>
    <td>
        <?php
        echo $category->parent_id;
        ?>
    </td>
    <td align="center">
        <?php
        echo $published;
        ?>
    </td>
</tr>
<?php
$position++;
printCategoryList($category, $level+1, $position);
}
}
function renderOptionList( & $root)
{
    $optionList[0] = JHTML::_('select.option', '0', JText::_('LEAVE_AS_MAIN_CAT'));
    getOptionList($root, $optionList);
    return $optionList;
}
function getOptionList( & $root, & $optionList, $level = 0)
{
    $children = $root->getChildren();
    foreach ($children as $category)
    {
        $catprefix = '';
        for ($i = 0; $i < $level; $i++)
        $catprefix .= '&nbsp;&nbsp;';
        $category->name = $catprefix.$category->name;
        $option = new DjOptionCategory();
        $option->value = $category->id;
        $option->text = $category->name;
        $option->disable = null;
        $optionList[] = $option;
        getOptionList($category, $optionList, $level+1);
    }
}
function renderCategoryFilter( & $root)
{
    $optionList[0] = JHTML::_('select.option', '0', '- '.JText::_('Select Category').' -');
    getOptionList($root, $optionList);
    return $optionList;
}

function getChildrenList( & $root, $catid)
{
    $children = $root->getChildren();
	$childrenList = array();
	$found = false;
    if ( isset ($children[$catid]))
    {
		$childrenList[] = $catid;
        buildChildrenList($children[$catid], $childrenList);
		return $childrenList;
    }
    else
    {
        foreach ($children as $category)
        {
			$childrenList = getChildrenList($category, $catid);
			if (isset($childrenList)) {
				$found = true;
				break;
			}
        }
    }
	if ($found) return $childrenList;
}

function buildChildrenList(&$root, &$childrenList) {
	$children = $root->getChildren(); 
	
	foreach ($children as $id => $category) {
		$childrenList[] = $id;
		buildChildrenList($category, $childrenList);
	}
}
