<?php

/**
* @version		1.2
* @package		DJ Catalog
* @subpackage	DJ Catalog Component
* @copyright	Copyright (C) 2007 - 2008 DJ-Projects. All rights reserved.
* @license		This code cannot be redistributed without permission from DJ-Projects - http://design-joomla.eu
* @autor url    http://design-joomla.eu
* @autor email  sales@design-joomla.eu
* @Developers   Lukasz Ciastek - lukasz.ciastek@design-joomla.eu, Michal Olczyk - michal.olczyk@design-joomla.eu
*/

defined ('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.model');

/*Items Model*/


class DjcatalogModelItems extends JModel{
	
	var $_items;
	var $_categories;
	
	//budowa klauzuli where do zapytania przy filtrowaniu
	function _buildQueryWhere(){
		global $mainframe, $option;
		
		$filter_state = $mainframe->getUserStateFromRequest($option.'filter_state', 'filter_state');
		
		$where ='';
		
		if($filter_state =='P'){
			$where = 'i.published = 1';
		}
		elseif($filter_state == 'U'){
			$where = 'i.published = 0';
		}
		
		return ($where) ? ' AND '.$where : '';
	}
	
	
	//pobieranie itemow
	function getItems(){
		global $mainframe, $option;
		$order = JRequest::getVar('order','ordering','default','string');
		$cid		= $mainframe->getUserStateFromRequest( 'cat_id',		'cat_id',		0,				'int' );
		$ord ='';
		$c = '';
		if($order=='category'){
			$ord = ' cat_name';
		}
		elseif($order=='producer'){
			$ord = ' p_name';
		}
		elseif($order=='id'){
			$ord = ' i.id';
		}
		elseif($order=='published'){
			$ord = ' i.published';
		}
		elseif($order=='name'){
			$ord = ' i.name';
		}
		elseif($order=='ordering'){
			$ord = ' i.ordering';
			JRequest::setVar('order','ordering');
		}
		
		if($cid){
			$c = ' AND i.cat_id LIKE '.$cid.'';
		}
		
		$find_name=JRequest::getVar('find_name');
		$fn='';
		if($find_name){
			$fn=" AND i.name LIKE '%".$find_name."%' ";
		}
		
		$limit = JRequest::getVar('limit', 10, '', 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		if(!$this->_items){
			
			$query = "SELECT i.* ,c.id as cat_id, c.name as cat_name, p.id as p_id, p.name as p_name "
					."FROM #__djcat_items i , #__djcat_categories c, #__djcat_producer p "
					."WHERE c.id = i.cat_id AND p.id = i.producer_id ".$c." ".$fn." "
					."ORDER BY ".$ord." ";

			$this->_items = $this->_getList($query, $limitstart, $limit);
		}
		return $this->_items;
	}
	
	function getCount(){
		global $mainframe, $option;
		$cid		= $mainframe->getUserStateFromRequest( 'cat_id',		'cat_id',		0,				'int' );
		$wherecat = '';
		if($cid){
			$wherecat = ' WHERE cat_id LIKE '.$cid.'';
		}

		$find_name=JRequest::getVar('find_name');
		$fn='';
		if($find_name){
			$fn=" AND name LIKE '%".$find_name."%' ";
		}		
		
		$db= &JFactory::getDBO();
		$query = "SELECT COUNT(*) FROM #__djcat_items".$wherecat." ".$fn;

		$db->setQuery($query);
		$allelems=$db->loadResult();


		return $allelems;
	}
	
	//pobieranie kategorii do wylistowania - alfabetycznie
	function getCategories(){
		
		if(!$this->_categories){
			
			$query = "SELECT * FROM #__djcat_categories ORDER BY name";
			
			$this->_categories = $this->_getList($query,0,0);
		}
		
		return $this->_categories;
	}
	
}
?>
