<?php
/**
* @version		1.2
* @package		DJ Catalog
* @subpackage	DJ Catalog Component
* @copyright	Copyright (C) 2007 - 2008 DJ-Projects. All rights reserved.
* @license		This code cannot be redistributed without permission from DJ-Projects - http://design-joomla.eu
* @autor url    http://design-joomla.eu
* @autor email  sales@design-joomla.eu
* @Developers   Lukasz Ciastek - lukasz.ciastek@design-joomla.eu, Michal Olczyk - michal.olczyk@design-joomla.eu
*/
defined ('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');


class DJCatalogViewShow extends JView {
	function display($tpl = null) {
		global $mainframe;
		
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'cattree.php');
		$document=& JFactory::getDocument();
		$cs = JURI::base().'components'.DS.'com_djcatalog'.DS.'views'.DS.'show'.DS.'tmpl'.DS.'style.css';
		$document->addStyleSheet($cs); 
		
		$model =& $this->getModel();
	    $el_id= JRequest::getVar('cid', 0, '', 'int');
		
		$params = &JComponentHelper::getParams( 'com_djcatalog' );
	
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();	
		
		if ($el_id=="" || $el_id == 0){
			$lista_items = $model->getAllElements();
			$lista_count_items=$model->getAllCountElements();
			
			if (is_object( $menu )) {
				$menu_params = new JParameter( $menu->params );
				if (!$menu_params->get( 'page_title')) {
					$params->set('page_title',	JText::_('ALL_ITEMS'));
				}
			} 
			else {
				$params->set('page_title',	JText::_('ALL_ITEMS'));
			}
		}
		else {
			$li = $model->getCategory($el_id);
			$categories=$model->getCategories();
			$tree = new CatTree();
        	$tree->buildTree($categories);
        	$root = & $tree->getRoot();
			$catList = getChildrenList($root, $el_id);
			
			$lista_items=$model->getElements($catList);
			$lista_count_items=$model->getCountElements($catList);
			
			if (is_object( $menu )) {
				$menu_params = new JParameter( $menu->params );
				if (!$menu_params->get( 'page_title')) {
					$params->set('page_title',	$li->name);
				}
			} 
			else {
				$params->set('page_title',	$li->name);
			}				
		}
		
		$document->setTitle( $params->get( 'page_title' ) );
		
		jimport('joomla.html.pagination');
		JHTML::_( 'behavior.modal' );
		
		$limit		= $params->get('limit_items_show', 10);
		$limitstart	= JRequest::getVar('limitstart', 0, 'default', 'int');

		$pagination = new JPagination($lista_count_items, $limitstart, $limit);

		$pu=$params->get('price_unit');
		$us=$params->get('unit_side');
		$se=$params->get('search_items');
		
		$dec_sep = null;
		$th_sep = null;
		
		switch($params->get('thousand_separator',0)) {
			case 0: $th_sep=''; break;
			case 1: $th_sep=' '; break;
			case 2: $th_sep='\''; break;
			case 3: $th_sep=','; break;
			default: $th_sep=''; break;
		}
		
		switch($params->get('decimal_separator',0)) {
			case 0: $dec_sep=','; break;
			case 1: $dec_sep='.'; break;
			default: $dec_sep=','; break;
		}
		$showprice = $params->get('show_price');
		$showfooter = $params->get('show_footer');
		$footer = '<div style="margin: 0 auto; clear: both; text-align: center; width: 100%"><br /><a target="_blank" href="http://design-joomla.eu">joomla templates &amp; addons</a></div>';
		
		/* PATHWAY */
		
		$app = & JFactory::getApplication();
    	$pathway = & $app->getPathway();
		$catpath = $model->getPath($el_id);
		
		$layout = JRequest::getVar('layout', 'default', 'default', 'string');
		
		for ($i = count($catpath) - 1; $i >= 0;  $i--) {
			if($i == 0 || count($catpath) == 1)
				$pathway->addItem($catpath[$i]['name']);
			else
				$pathway->addItem($catpath[$i]['name'], JRoute::_('index.php?option=com_djcatalog&view=show&layout='.$layout.'&cid='.$catpath[$i]['id']));
		}
		
		$this->assignRef('pagination',$pagination);
		$this->assignRef('items',$lista_items);
		//$this->assignRef('li',$li);
		$this->assignRef('price_unit',$pu);
		$this->assignRef('unit_side',$us);
		$this->assignRef('dec_sep',$dec_sep);
		$this->assignRef('th_sep',$th_sep);
		$this->assignRef('showprice',$showprice);
		$this->assignRef('showfooter',$showfooter);
		$this->assignRef('footer',$footer);
		$this->assignRef('search',$se);
		$this->assignRef('params',	$params);

        parent::display($tpl);
	}

}




