<?php
/**
* @version		1.2
* @package		DJ Catalog
* @subpackage	DJ Catalog Component
* @copyright	Copyright (C) 2007 - 2008 DJ-Projects. All rights reserved.
* @license		This code cannot be redistributed without permission from DJ-Projects - http://design-joomla.eu
* @autor url    http://design-joomla.eu
* @autor email  sales@design-joomla.eu
* @Developers   Lukasz Ciastek - lukasz.ciastek@design-joomla.eu, Michal Olczyk - michal.olczyk@design-joomla.eu
*/
defined ('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class DJCatalogViewShowitem extends JView

{
	var $row;
	var $pagination;
	function display($tpl = null)

    
    {
    global $mainframe;
    $par = & $mainframe->getParams('com_djcatalog');
    JHTML::_('behavior.modal');
    $model = & $this->getModel();
    $item_id = JRequest::getVar('id', 0, '', 'int');
    $this->row = $model->getItem($item_id);
    $document = & JFactory::getDocument();
    $cs = JURI::base().'components'.DS.'com_djcatalog'.DS.'views'.DS.'showitem'.DS.'tmpl'.DS.'style.css';
    $document->addStyleSheet($cs);
	
	$params = $mainframe->getParams();

	$menus	= &JSite::getMenu();
	$menu	= $menus->getActive();

	if (is_object( $menu )) {
		$menu_params = new JParameter( $menu->params );
		if (!$menu_params->get( 'page_title')) {
			$params->set('page_title',	$this->row->cat_name);
		}
	} else {
		$params->set('page_title',	$this->row->cat_name);
	}
	$document->setTitle( $params->get( 'page_title' ).' - '.$this->row->name );
	
	$pu=$par->get('price_unit');
	$us=$par->get('unit_side');
	
	$dec_sep = null;
	$th_sep = null;
	
	$par_th_sep=$par->get('thousand_separator',0);
	switch($par_th_sep) {
		case 0: $th_sep=''; break;
		case 1: $th_sep=' '; break;
		case 2: $th_sep='\''; break;
		case 3: $th_sep=','; break;
		default: $th_sep=''; break;
	}
	
	$par_dec_sep=$par->get('decimal_separator',0);
	switch($par_dec_sep) {
		case 0: $dec_sep=','; break;
		case 1: $dec_sep='.'; break;
		default: $dec_sep=','; break;
	}
	
	$showprice = $par->get('show_price');
	$showfooter = $par->get('show_footer');
	$footer = '<div style="margin: 0 auto; clear: both; text-align: center; width: 100%"><br /><a target="_blank" href="http://design-joomla.eu">joomla templates &amp; addons</a></div>';

	
	/* IMAGES ARRAY */
	$images = array();
	if($this->row->image_url) {
		$temp = explode(";",$this->row->image_url);
		for($i=0; $i<count($temp)-1;$i++ )  
                $images[] = '<a class="modal dj_thumbnail" href="'.JURI::base().'components/com_djcatalog/images/'.$temp[$i].'" target="_blank"><img src="'.JURI::base().'components/com_djcatalog/images/'.$temp[$i].'.th.jpg" style="top: 0;" alt="'.$this->row->name.'" /></a>';
	}
	
	/* FILES ARRAY */
	$files = array();
	if($this->row->files_url){
		$temp = explode(";",$this->row->files_url);
		for($i=0; $i<count($temp)-1;$i++ ){
			$file=explode(".", substr($temp[$i], 32));
            $fileHTML = '<a href="'.JURI::base().'components/com_djcatalog/files/'.$temp[$i].'" class="dj_file" title="'.substr($temp[$i],32).'">';
			switch($file[1]){
				case 'pdf':{
					$obrazek='pdf.png';
					break;
				}
				case 'zip':
				case 'rar':
				{
					$obrazek='rar.png';
					break;
				}
				case 'mp3':
				case 'ogg':
				case 'wav':
				{
					$obrazek='mp3.png';
					break;
				}
				case 'doc':
				case 'docx':
				{
					$obrazek='word.png';
					break;
				}
				case 'xls':
				case 'xlsx':
				{
					$obrazek='excel.png';
					break;
				}
				case 'mov':
				case 'avi':
				case 'mpeg':
				case 'mpg':
				case 'wmv':
				{
					$obrazek='movie.png';
					break;
				}
				default:{
					$obrazek='other.png';
					break;
				}
			}
			$fileHTML .= '<img src="'.JURI::base().'/components/com_djcatalog/icons/'.$obrazek.'" alt="'.$file[0].'" width="16" height="16" class="dj_icon" /><span>'.$file[0].'</span></a>';
			$files[] = $fileHTML;
			}	
		}
	
	$this->assignRef('files',$files);
	$this->assignRef('images',$images);
	$this->assignRef('price_unit',$pu);
	$this->assignRef('unit_side',$us);
	$this->assignRef('dec_sep',$dec_sep);
	$this->assignRef('th_sep',$th_sep);
	$this->assignRef('showprice',$showprice);
	$page = (int)JRequest::getInt('limitstart', 0);
	$this->ContentPagebreak($this->row, $this->pagination, $page);
	
	$this->assignRef('item',$this->row);
	$this->assignRef('pagination',$this->pagination);
	
	$this->assignRef('showfooter',$showfooter);
	$this->assignRef('footer',$footer);
	$this->assignRef('params',	$params);
	
	 /* PATHWAY */
    $app = & JFactory::getApplication();
    $pathway = & $app->getPathway();
	$catpath = $model->getPath($this->row->cat_id);
	
	$layout = JRequest::getVar('layout', 'default', 'default', 'string');
	
	for ($i = count($catpath) - 1; $i >= 0;  $i--) {
		$pathway->addItem($catpath[$i]['name'], JRoute::_('index.php?option=com_djcatalog&view=show&layout='.$layout.'&cid='.$catpath[$i]['id']));
	}
    $pathway->addItem($this->row->name);
	
	parent::display($tpl);
	}
function ContentPagebreak( &$row, &$pagination,$page=0 )
{

	$regex = '#<hr([^>]*?)class=(\"|\')system-pagebreak(\"|\')([^>]*?)\/*>#iU';

	if(!$page) {
		$page = 0;
	}
	
	$matches = array();
	preg_match_all( $regex, $row->description, $matches, PREG_SET_ORDER );

	$text = preg_split( $regex, $row->description );

	$n = count( $text );

	if ($n > 1)
	{
		if ( $page ) {
			$page_text = $page + 1;
			if ( $page && @$matches[$page-1][2] )
			{
				$attrs = JUtility::parseAttributes($matches[$page-1][1]);

				if ( @$attrs['title'] ) {
					$row->name = $attrs['title'];
				}
			}
		}
		$row->description = '';

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $n, $page, 1 );

		$text[$page] = str_replace("<hr id=\"\"system-readmore\"\" />", "", $text[$page]);
		$row->description .= $text[$page];

		$pagination .= '<div class="pagenavbar">';
		$pagination .= $pageNav->getPagesLinks();
		$pagination .= '</div>';
		$pagination .= '<div class="pagenavcounter">';
		$pagination .= $pageNav->getPagesCounter();
		$pagination .= '</div>';
	}
	return true;
}

function ContentCreateNavigation( &$row, $page, $n )
{
	$pnSpace = "";
	if (JText::_( '&lt' ) || JText::_( '&gt' )) $pnSpace = " ";

	if ( $page < $n-1 )
	{
		$page_next = $page + 1;

		$link_next = JRoute::_( '&limitstart='. ( $page_next ) );
		// Next >>
		$next = '<a href="'. $link_next .'">' . JText::_( 'Next' ) . $pnSpace . JText::_( '&gt' ) . JText::_( '&gt' ) .'</a>';
	}
	else
	{
		$next = JText::_( 'Next' );
	}

	if ( $page > 0 )
	{
		$page_prev = $page - 1 == 0 ? "" : $page - 1;

		$link_prev = JRoute::_(  '&limitstart='. ( $page_prev) );
		// << Prev
		$prev = '<a href="'. $link_prev .'">'. JText::_( '&lt' ) . JText::_( '&lt' ) . $pnSpace . JText::_( 'Prev' ) .'</a>';
	}
	else
	{
		$prev = JText::_( 'Prev' );
	}

	$row->text .= '<div>' . $prev . ' - ' . $next .'</div>';
}

}

?>