<?php
/**
* @version		1.00
* @package		DJ Catalog
* @subpackage	DJ Catalog Menu Module
* @copyright	Copyright (C) 2007 - 2008 DJ-Projects. All rights reserved.
* @license		This code cannot be redistributed without permission from DJ-Projects - http://design-joomla.eu
* @autor url    http://design-joomla.eu
* @autor email  sales@design-joomla.eu
* @Developers   Michal Olczyk - michal.olczyk@design-joomla.eu
*/

function renderMenu(&$root, $catid, $Itemid, $layout = 1, $expand) {
		
	$levels = array();
	makeDjCatTree(0, $levels, $root);
	if ($layout == 1)
		$lay = 'blog';
	else $lay ='default';
	if (count($levels))
		renderList($levels, 0, $catid, $Itemid, $lay, $expand);
}

function renderList(&$list, $current, $catid, $Itemid, $lay, $expand, $level=0) {
	
	foreach ($list[$current] as $key=>$value) {
		$active = false;
		$activeChildren = 0;
		$class='class="';
		$id='';
		checkIfActive($list, $key, $catid, $activeChildren);
		if ($key == $catid || $activeChildren) {
			$active = true;
			$class.='active';
			if ($key == $catid)
				$id='id="current"';
		}
		if (isset($list[$key]))
			if (count($list[$key]))
				$class.=' parent';
		$class.=' level'.$level.'"';
		echo('<li '.$class.' '.$id.'>');
		echo JHTML::link(JRoute::_('index.php?option=com_djcatalog&view=show&cid='.$key.'&Itemid='.$Itemid.'&layout='.$lay), '<span>'.$value.'</span>');
		if (isset($list[$key]) && ($active || $expand))
			if (count($list[$key])) {
			echo('<ul>');
			renderList($list, $key, $catid, $Itemid, $lay, $expand, $level+1);
			echo('</ul>');
		}
		echo('</li>');
	}
}

function checkIfActive (&$list, $current, $catid, &$check) {

	if (isset($list[$current]))
			if (count($list[$current])) {
		foreach ($list[$current] as $key=>$value) {
			if ($key == $catid) {
				$check++;
			}
			elseif (isset($list[$key]))
				if (count($list[$key]))
					checkIfActive($list, $key, $catid,$check);
		}
	}
}

function renderSelect(&$root, $catid) {
		
	$levels = array();
	makeDjCatTree(0, $levels, $root);
	if (count($levels))
		renderOptions($levels, 0, $catid, $selected);
}

function renderOptions(&$list, $current, $catid, $level=0) {
	
	foreach ($list[$current] as $key=>$value) {		
		if ($key == $catid)
			$selected='selected="selected"';
		$indent='';
		for ($i = 0; $i < $level; $i++) {
			$indent .= '--';
		}
		echo '<option value="'.$key.'">'.$indent.' '.$value.'</option>';
		if (count($list[$key])) {
			renderOptions($list, $key, $catid, $level+1);
		}
	}
}

function makeDjCatTree($parentid, &$tab, $table) {
	
	foreach($table as $value) {
		if ($value->parent_id == $parentid) {
			$catid = $value->id;
			$tab[$parentid][$catid]= $value->name;
			makeDjCatTree($value->id, $tab, $table);
		}
	}	
}



class DjcatalogModelCategories{
	
	var $_categories;
	
	function getCategories(){
		$db= &JFactory::getDBO();
			$query = "SELECT * FROM #__djcat_categories WHERE published = 1";
			$db->setQuery($query);
			$_categories=$db->loadObjectList();
		

		return $_categories;
	}
}
?>
